=== debian/changelog ===
freedv (1.4.3~1gdc71a1c-1) unstable; urgency=medium

  [ Christoph Berg ]
  * Use https homepage.
  * Add debian/gitlab-ci.yml.
  * Update description. (Closes: #935795)

  [ A. Maitland Bottoms ]
  * update to 1.4.3 using dc71a1c pending upstream release
  * update standards-version
  * Add upstream/metadata

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 17 Oct 2020 15:26:20 -0400
