## freedv 1.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,9 +6,9 @@
 # mailing list: https://lists.sourceforge.net/lists/listinfo/freetel-codec2
 #
 
-set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version")
-
-cmake_minimum_required(VERSION 2.8)
+set(CMAKE_OSX_DEPLOYMENT_TARGET "10.11" CACHE STRING "Minimum OS X deployment version")
+
+cmake_minimum_required(VERSION 3.0)
 
 # Prevent in-source builds to protect automake/autoconf config.
 # If an in-source build is attempted, you will still need to clean up a few
@@ -16,7 +16,7 @@
 set(CMAKE_DISABLE_SOURCE_CHANGES ON)
 set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
 if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
-  message(FATAL_ERROR "In-source builds in ${CMAKE_BINARY_DIR} are not "   
+  message(FATAL_ERROR "In-source builds in ${CMAKE_BINARY_DIR} are not "
    "allowed, please remove ./CMakeCache.txt and ./CMakeFiles/, create a "
    "separate build directory and run cmake from there.")
 endif("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
@@ -25,6 +25,11 @@
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 
 project(FreeDV)
+
+# Build universal ARM64 and x86_64 binaries on Mac.
+if(BUILD_OSX_UNIVERSAL)
+set(CMAKE_OSX_ARCHITECTURES "x86_64;arm64")
+endif(BUILD_OSX_UNIVERSAL)
 
 # https://cmake.org/cmake/help/git-stage/policy/CMP0075.html
 if(POLICY CMP0075)
@@ -43,14 +48,11 @@
 # Set FreeDV version and generate src/version.h
 #
 set(FREEDV_VERSION_MAJOR 1)
-set(FREEDV_VERSION_MINOR 4)
-set(FREEDV_VERSION_PATCH 3)
-set(FREEDV_VERSION_SUFFIX "devel")
-
-set(FREEDV_VERSION ${FREEDV_VERSION_MAJOR}.${FREEDV_VERSION_MINOR})
-if(FREEDV_VERSION_PATCH)
-    set(FREEDV_VERSION ${FREEDV_VERSION}.${FREEDV_VERSION_PATCH})
-endif()
+set(FREEDV_VERSION_MINOR 7)
+set(FREEDV_VERSION_PATCH 0)
+set(FREEDV_VERSION_SUFFIX "")
+
+set(FREEDV_VERSION ${FREEDV_VERSION_MAJOR}.${FREEDV_VERSION_MINOR}.${FREEDV_VERSION_PATCH})
 if(FREEDV_VERSION_SUFFIX)
     set(FREEDV_VERSION_STRING "${FREEDV_VERSION} ${FREEDV_VERSION_SUFFIX}")
 else()
@@ -105,9 +107,9 @@
 set(CMAKE_VERBOSE_MAKEFILE TRUE CACHE BOOL "Verbose makefile.")
 set(USE_INTERNAL_CODEC2 FALSE CACHE BOOL
     "Download and build codec2 and lpcnetfreedv instead of using the system library.")
-set(USE_STATIC_DEPS FALSE CACHE BOOL 
+set(USE_STATIC_DEPS FALSE CACHE BOOL
     "Download and build static libraries instead of system libraries.")
-set(USE_STATIC_PORTAUDIO FALSE CACHE BOOL 
+set(USE_STATIC_PORTAUDIO FALSE CACHE BOOL
     "Download and build static portaudio instead of the system library.")
 set(USE_STATIC_SNDFILE FALSE CACHE BOOL
     "Download and build static sndfile instead of the system library.")
@@ -117,6 +119,8 @@
     "Download and build static speex instead of the system library.")
 set(BOOTSTRAP_WXWIDGETS FALSE CACHE BOOL
     "Download and build static wxWidgets instead of the system library.")
+set(USE_PULSEAUDIO FALSE CACHE BOOL
+    "Use PulseAudio instead of PortAudio for audio I/O.")
 
 if(USE_STATIC_DEPS)
     set(USE_STATIC_PORTAUDIO TRUE FORCE)
@@ -201,7 +205,7 @@
 include(CheckSymbolExists)
 check_symbol_exists("_fseeki64" "stdio.h" HAVE__FSEEKI64)
 
-# fdmdv2_main.h requires patching to find config.h as it current looks in the
+# main.h requires patching to find config.h as it current looks in the
 # source directory and the generated file goes in the binary directory.
 configure_file ("${PROJECT_SOURCE_DIR}/cmake/config.h.in"
                 "${PROJECT_BINARY_DIR}/config.h" )
@@ -268,7 +272,7 @@
             include_directories(${CODEC2_INCLUDE_DIRS})
         else()
             message(FATAL_ERROR "codec2 library not found.
-Linux: 
+Linux:
 Codec2 may not be in your distribution so build yourself or use the cmake option to build internally.
 Windws:
 It's easiest to use the cmake option: USE_INTERNAL_CODEC2 or use build trees for codec2 and lpcnetfreedv."
@@ -279,15 +283,19 @@
 
 
 #
-# Find or build portaudio Library
-#
-if(NOT USE_STATIC_PORTAUDIO)
+# Find or build portaudio/PulseAudio Library
+#
+if(NOT USE_STATIC_PORTAUDIO AND NOT USE_PULSEAUDIO)
     message(STATUS "Looking for portaudio...")
-    find_package(Portaudio REQUIRED)
+    find_package(portaudio-2.0 REQUIRED)
     if(PORTAUDIO_FOUND)
         message(STATUS "  portaudio library: ${PORTAUDIO_LIBRARIES}")
         message(STATUS "  portaudio headers: ${PORTAUDIO_INCLUDE_DIRS}")
+        if(pkgcfg_lib_PORTAUDIO_portaudio)
+        list(APPEND FREEDV_LINK_LIBS ${pkgcfg_lib_PORTAUDIO_portaudio})
+        else(pkgcfg_lib_PORTAUDIO_portaudio)
         list(APPEND FREEDV_LINK_LIBS ${PORTAUDIO_LIBRARIES})
+        endif(pkgcfg_lib_PORTAUDIO_portaudio)
         include_directories(${PORTAUDIO_INCLUDE_DIRS})
     else()
         message(FATAL_ERROR "portaudio library not found.
@@ -300,35 +308,20 @@
     if(NOT ${PORTAUDIO_VERSION} EQUAL 19 AND NOT MINGW)
         message(WARNING "Portaudio versions other than 19 are known to have issues. You have been warned!")
     endif()
-else(NOT USE_STATIC_PORTAUDIO)
-    message(STATUS "Will attempt static build of portaudio.")
-    include(cmake/BuildPortaudio.cmake)
-endif(NOT USE_STATIC_PORTAUDIO)
-
-#
-# Hamlib library
-#
-message(STATUS "Looking for hamlib...")
-find_path(HAMLIB_INCLUDE_DIR hamlib/rig.h)
-find_library(HAMLIB_LIBRARY hamlib PATH_SUFFIXES hamlib)
-message(STATUS "  Hamlib library: ${HAMLIB_LIBRARY}")
-message(STATUS "  Hamlib headers: ${HAMLIB_INCLUDE_DIR}")
-if(HAMLIB_LIBRARY AND HAMLIB_INCLUDE_DIR)
-    message(STATUS "Hamlib library found.")
-    include_directories(${HAMLIB_INCLUDE_DIR})
-    list(APPEND FREEDV_LINK_LIBS ${HAMLIB_LIBRARY})
-else(HAMLIB_LIBRARY AND HAMLIB_INCLUDE_DIR)
-    message(FATAL_ERROR "hamlib not found.
+elseif(USE_PULSEAUDIO)
+    message(STATUS "Finding PulseAudio...")
+    find_package(PulseAudio REQUIRED)
+    if(PULSEAUDIO_FOUND)
+        message(STATUS "  PulseAudio library: ${PULSEAUDIO_LIBRARY}")
+        message(STATUS "  PulseAudio headers: ${PULSEAUDIO_INCLUDE_DIR}")
+        list(APPEND FREEDV_LINK_LIBS ${PULSEAUDIO_LIBRARY})
+        include_directories(${PULSEAUDIO_INCLUDE_DIR})
+        add_definitions(-DAUDIO_ENGINE_PULSEAUDIO_ENABLE)
+    else()
+        message(FATAL_ERROR "PulseAudio library not found.
 On Linux systems try installing:
-    hamlib-devel  (RPM based systems)
-    libhamlib-dev (DEB based systems)"
-    )
-endif(HAMLIB_LIBRARY AND HAMLIB_INCLUDE_DIR)
-
-
-#
-# Samplerate Library
-#
-if(NOT USE_STATIC_SAMPLERATE)
-    message(STATUS "Looking for samplerate...")
-    find_library(LIBSAMPLERATE samplerate)
+    pulseaudio-libs-devel  (RPM based systems)
+    libpulse-dev           (DEB based systems)
+")
+     endif()
+else()
