=== debian/changelog ===
freedv (1.7.0-1) unstable; urgency=medium

  * New upstream release.
    Pulseaudio support

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 06 Feb 2022 11:19:49 -0500

freedv (1.6.1-2) unstable; urgency=medium

  * upload to master since codec2 1.0.1 is already there.

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 07 Dec 2021 20:05:58 -0500

freedv (1.6.1-1) experimental; urgency=medium

  * New upstream release.
  * build without buggy AVX instruction test

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 10 Nov 2021 23:11:11 -0500
