=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
                debhelper-compat (= 13),
 	       libcodec2-dev (>= 0.9),
                libhamlib-dev,
+	       libpulse-dev,
                libsamplerate-dev,
                libsndfile-dev,
                libspeexdsp-dev,
