## freedv 1.8.2

=== debian/changelog ===
freedv (1.8.2-1) unstable; urgency=medium

  [ Daniele Forsi ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Update standards version to 4.6.0, no changes needed.

  [ A. Maitland Bottoms ]
  * New upstream release.
  * Update standards version to 4.6.1, no changes needed.

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 13 Aug 2022 15:23:50 -0400

freedv (1.7.0-2) unstable; urgency=medium

  * Actually Enable building with pulseaudio (Thanks wolfgang!)
    (Closes: #1006419)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 28 Mar 2022 20:28:17 -0400
