=== debian/control ===
--- 
+++ 
@@ -5,15 +5,15 @@
 Uploaders: A. Maitland Bottoms <bottoms@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
-	       libcodec2-dev (>= 0.9),
+               libcodec2-dev (>= 0.9),
                libhamlib-dev,
-	       libpulse-dev,
+               libpulse-dev,
                libsamplerate-dev,
                libsndfile-dev,
                libspeexdsp-dev,
                libwxgtk3.0-gtk3-dev,
                portaudio19-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://freedv.org/
 Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/freedv
